<?php

if ($_SERVER["REQUEST_METHOD"] == "POST") {

    ini_set('memory_limit', '4096M'); // 2 GB memory limit
    ini_set('max_execution_time', 3600); // 20 minutes
    ini_set('max_input_nesting_level', 256);
    ini_set('max_input_time', 3600);
    ini_set('max_input_vars', 18000);
    ini_set('post_max_size', '4096M');
    ini_set('upload_max_filesize','4096M');   






    // Generate CSV content
    $conversionRate = isset($_POST['conversionRate']) ? (float)$_POST['conversionRate'] : 1.0;
   // Database connection
// Database connection
 $servername = "localhost";
                        $username = "efox_dataEntry";
                        $password = "qYkVUsc5ST8mAXR2kWce";
                        $dbname = "efox_dataEntry";


    // Generate CSV content
    $csvData = generateCSV($_POST['products'], $conversionRate);

    // Set headers to force download
    header("Content-Type: text/csv");
    header("Content-Disposition: attachment; filename=products.csv");

    // Output CSV data directly to the browser
    echo $csvData;
    exit();
}
function generateCSV($products, $conversionRate) {
    ob_start(); // Start output buffering

    // Open output stream
    $csvFile = fopen("php://output", 'w');

    // Write CSV headers
    $headers = [
        "productID",
        "productName",
        "productDescription",
        "dataCenterCode",
        "productGroup",
        "provider",
        "configOptionGroupName",
        "configSubOptionName",
        "configSubOptionMonthlyPrice",
        "configSetupPrice",
        "productMonthlyPrice",
        "productMonthlySetupPrice",
    ];

    fputcsv($csvFile, $headers);

    foreach ($products as $product) {
        // Check if any main product field contains the word "error"
        $productFields = [
            $product['productID'],
            $product['productName'],
            $product['productDescription'],
            $product['dataCenterCode'],
            $product['productGroup'],
            $product['provider']
        ];

        // Convert all fields to string and search for the word "error" (case-insensitive)
        $productContainsError = false;
        foreach ($productFields as $field) {
            if (stripos((string)$field, 'error') !== false) {
                $productContainsError = true;
                break;
            }
        }

        // If the word "error" is found in the main product fields, skip this product
        if ($productContainsError) {
            continue;
        }

        // Process the main product prices
        $productID = $product['productID'];
        $productName = $product['productName'];
        $productDescription = $product['productDescription'];   
        $dataCenterCode = $product['dataCenterCode'];
        $productGroup = $product['productGroup'];
        $provider = $product['provider'];
        $productMonthlyPrice = $product['productMonthlyPrice'];
        $productMonthlySetupPrice = $product['productMonthlySetupPrice'];
        $adjustedProductMonthlySetupPrice = $productMonthlySetupPrice * $conversionRate * 2;
        $adjustedMonthlyPriceConversion = $productMonthlyPrice * $conversionRate;
        $adjustedMonthlyPrice = applyPriceFormula($adjustedMonthlyPriceConversion);

        // Randomly add or deduct from 1 to 10
        $randomAdjustment = rand(-10, 10);
        $adjustedMonthlyPrice += $randomAdjustment;
        
        $productAnnualPrice = $adjustedMonthlyPrice * 12;

        if (isset($product['configOptionGroupName'])) {
            foreach ($product['configOptionGroupName'] as $key => $groupName) {
                // Check if groupName contains the word "error"
                if (stripos((string)$groupName, 'error') !== false) {
                    continue; // Skip if "error" is found in config group name
                }

                foreach ($product['configSubOptionName'][$key + 1] as $index => $subOptionName) {
                    $monthlyPrice = $product['configSubOptionMonthlyPrice'][$key + 1][$index];
                    $configSetupPrice = $product['configSetupPrice'][$key + 1][$index];

                    // Check if sub-option contains the word "error"
                    if (
                        stripos((string)$subOptionName, 'error') !== false || 
                        stripos((string)$monthlyPrice, 'error') !== false ||
                        stripos((string)$configSetupPrice, 'error') !== false
                    ) {
                        continue; // Skip if "error" is found in sub-option or pricing
                    }

                    $adjustedSubOptionMonthlyPriceConversion = $monthlyPrice * $conversionRate;
                    $adjustedSubOptionMonthlyPrice = applySubOptionPriceFormula($adjustedSubOptionMonthlyPriceConversion);

                    $rowData = [
                        $productID,
                        $productName,
                        $productDescription,
                        $dataCenterCode,
                        $productGroup,
                        $provider,
                        $groupName,
                        $subOptionName,
                        $adjustedSubOptionMonthlyPrice,
                        $configSetupPrice * $conversionRate * 2,
                        $adjustedMonthlyPrice,
                        $adjustedProductMonthlySetupPrice
                    ];

                    fputcsv($csvFile, $rowData);
                }
            }
        }

        // Add an empty row after each product
        fputcsv($csvFile, []);
    }

    // Close file handle
    fclose($csvFile);

    // Get buffered output
    $csvData = ob_get_clean();

    return $csvData;
}


function applyPriceFormula($price) {
    if ($price == 0) {
        return 0;
    } elseif ($price < 50) {
        return round($price + 30);
    } elseif ($price < 100) {
        return round($price + 35);
    } elseif ($price < 200) {
        return round($price + 40);
    } elseif ($price < 500) {
        return round($price + 85);
    } elseif ($price < 750) {
        return round($price + 150);
    } elseif ($price < 1000) {
        return round($price + 200);
    } elseif ($price < 2000) {
        return round($price + 350);
    } elseif ($price < 3000) {
        return round($price + 500);
    } elseif ($price < 4000) {
        return round($price + 750);
    } elseif ($price < 5000) {
        return round($price + 1000);
    } else {
        return round($price);
    }
}

// Function to apply the sub-option price formula and round the result
function applySubOptionPriceFormula($price) {
    if ($price == 0) {
        return 0;
    } elseif ($price < 25) {
        return round($price + 10);
    } elseif ($price <= 500) {
        return round($price * 1.25);
    } else {
        return round($price * 1.5);
    }
}

?>


