<?php
session_start(); // Start the session at the beginning
ini_set('memory_limit', '4096M'); // 2 GB memory limit
    ini_set('max_execution_time', 3600); // 20 minutes
    ini_set('max_input_nesting_level', 256);
    ini_set('max_input_time', 3600);
    ini_set('max_input_vars', 18000);
    ini_set('post_max_size', '4096M');
    ini_set('upload_max_filesize','4096M');   
// Debugging: Check if the session variable is set
if(isset($_SESSION['tableName'])) {
    $tableName = $_SESSION['tableName'];
} else {
    $tableName = "Session variable not set.";
}


?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Product Form</title>
    <link rel="stylesheet" href="https://kit.fontawesome.com/b27b646f22.css" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <style>
        body {
            font-family: Arial, sans-serif;
            background-color: #00274e;
            margin: 0;
            padding: 0;
            display: flex;
            justify-content: center;
            align-items: center;
        }
        .container {
            background-color: #ffffff;
            padding: 20px;
            border-radius: 8px;
            box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
            width: 100%;
            max-width: 1600px;
        }
        h3 {
            border-bottom: 2px solid #03ffa2;
            margin-bottom: 50px;
            background-color: #00274e;
            padding: 15px;
            color: #fff;
        }
        .form-group {
            display: flex;
            flex-wrap: wrap;
            margin-bottom: 10px;
        }
        .form-group > div {
            flex: 1;
            min-width: 200px;
            margin-right: 10px;
            margin-bottom: 10px;
        }
        label {
            display: block;
            margin-bottom: 8px;
            font-weight: bold;
        }
        input[type="text"],
        textarea {
            width: 90%;
            padding: 12px;
            border: 1px solid #a8c1db;
            border-radius: 4px;
        }
        input[type="float"], textarea {
    width: 90%;
    padding: 12px;
    border: 1px solid #a8c1db;
    border-radius: 4px;
}
        textarea {
            resize: vertical;
            height: 14px;
        }
        .product, .option-group, .sub-options {
            margin-bottom: 20px;
            padding: 10px;
            border: 1px solid #ced4da;
            border-radius: 4px;
            background-color: #ffffff;
        }
        .config-options {
            margin-bottom: 10px;
        }
        .add-suboption, .add-config, #add-product,  button[type="submit"] {
            background-color: #007bff;
            color: white;
            padding: 10px 15px;
            border: none;
            border-radius: 4px;
            cursor: pointer;
            margin: 10px;
        }
        .add-suboption:hover, .add-config:hover, #add-product:hover,button[type="submit"]:hover {
            background-color: #0056b3;
        }
        .option-group{
               background-color: #fff;
    padding: 50px;
        border: 34px solid #a2b2c1;
        }

   

.add-suboption{
        background-color: #18bbc1;
}
   
   
   
   .button {
	display: inline-block;
	font-family: "Montserrat", "Trebuchet MS", Helvetica, sans-serif;
	-webkit-font-smoothing: antialiased;
	position: relative;
	padding: 0.8em 1.4em;
	padding-right: 4.7em;
	background: @button-colour;
	border: none;
	color: white;
	transition: 0.2s;
	cursor:pointer;
	&:before,
	&:after {
		position: absolute;
		top: 0;
		bottom: 0;
		right: 0;
		padding-top: inherit;
		padding-bottom: inherit;
		width: 2.8em;
		content: "\00a0";
		font-family: "FontAwesome", sans-serif;
		font-size: 1.2em;
		text-align: center;

		transition: 0.2s;
		transform-origin: 50% 60%;
	}
	&:before {
		background: @button-tint;
	}
	&:hover {
		background: darken(@button-colour, 10%);
	}
	&:active,
	&:focus {
		background: darken(@button-colour, 30%);
		outline: none;
	}
}
.button a{
    text-decoration:none;
    color:#fff;
}
.button {
	min-width: 15em;
}

.arrow {
	background: #3573e9;
	&:hover {
		background: darken(#3573e9, 10%);
	}
	&:active,
	&:focus {
		background: darken(#3573e9, 30%);
	}
	&:after {
		content: "\F054";
	}
	&:hover:after {
		-webkit-animation: bounceright 0.3s alternate ease infinite;
		animation: bounceright 0.3s alternate ease infinite;
	}
}
.btn2{
        background-color: #aabd00;
    float: right;
}
@-webkit-keyframes bounceright {
	from {
		-webkit-transform: translateX(0);
	}
	to {
		-webkit-transform: translateX(3px);
	}
}

@-webkit-keyframes wiggle {
	from {
		-webkit-transform: rotate(0deg);
	}
	to {
		-webkit-transform: rotate(30deg);
	}
}


.tabname{
        background: #e7e7e7;
    padding: 20px;
    width: 300px;
    color: #060606;
    border-bottom-right-radius: 20px;
    font-family: monospace;
    font-weight: 900;
}
   .input-container {
            position: relative;
            display: inline-block;
            width: 100%; /* Adjust width as needed */
        }

        input[type="text"] {
            width: 100%;
            padding-right: 40px; /* Adjust padding for button */
            box-sizing: border-box; /* Ensures padding doesn't affect width */
        }
   .lock-btn {
            position: absolute;
            top: 37px; /* Adjust to control vertical position */
            right: 5px; /* Aligns the button at the right */
           
            border: none;
            color: #f44336;
            cursor: pointer;
            padding: 3px 6px;
            font-size: 12px;
            border-radius: 3px;
            line-height: 1;
        }

        .lock-btn:focus {
            outline: none;
        }
    </style>
</head>
<body>
<?php
$tableName = $_SESSION['tableName'];
?>
<link rel="stylesheet" href="//maxcdn.bootstrapcdn.com/font-awesome/4.3.0/css/font-awesome.min.css">
<link href='https://fonts.googleapis.com/css?family=Droid+Serif:400,700' rel='stylesheet' type='text/css'>
    <div class="container">
    <button class="button  arrow"><a href="initial.php" >Create New Table</a></button>
        <button class="button  arrow btn2"><a href="index2.php" >List Tables</a></button>
       <p class="tabname">Table : <?php echo htmlspecialchars($tableName); ?></p><br><br>
       
        <form action="generate_csv.php" method="post" id="productForm" enctype="application/x-www-form-urlencoded">
            <div class="form-group">
                <div>
                    <label for="conversionRate">Conversion Rate:</label>
                    <input type="float" id="conversionRate" name="conversionRate" required>
                </div>
                <div>
                    <label for="commonProvider">Common Provider:</label>
                    <input type="text" id="commonProvider" name="commonProvider">
                </div>
                <div>
                    <label for="commondataCenterCode">Common Data Center Code:</label>
                    <input type="text" id="commondataCenterCode" name="commondataCenterCode">
                </div>
            </div>
            <div id="products">
                <div class="product">
                    <h3>Product 1  </h3>
                    <div class="form-group">
                         <div class="input-container">
                            <label for="productID1">Product ID:</label>
                            <input type="text" id="productID1" name="products[1][productID]" required>
                              <button type="button" class="lock-btn" onclick="toggleLock('productID1')"><i class="fa-solid fa-lock"></i></button>
                        </div>
                        <div class="input-container">
                            <label for="productName1">Product Name:</label>
                            <input type="text" id="productName1" name="products[1][productName]" required>
                             <button type="button" class="lock-btn" onclick="toggleLock('productName1')"><i class="fa-solid fa-lock"></i></button>
                        </div>
                        <div class="input-container">
                            <label for="productDescription1">Product Description:</label>
                            <textarea id="productDescription1" name="products[1][productDescription]"></textarea>
                              <button type="button" class="lock-btn" onclick="toggleLock('productDescription1')"><i class="fa-solid fa-lock"></i></button>
                        </div>
                        <div class="input-container">
                            <label for="provider1">Provider:</label>
                            <input type="text" id="provider1" name="products[1][provider]" class="provider" required>
                              <button type="button" class="lock-btn" onclick="toggleLock('provider1')"><i class="fa-solid fa-lock"></i></button>
                        </div>
                        <div class="input-container">
                            <label for="dataCenterCode1">Data Center Code:</label>
                            <input type="text" id="dataCenterCode1" name="products[1][dataCenterCode]" class="dataCenterCode" required>
                              <button type="button" class="lock-btn" onclick="toggleLock('dataCenterCode1')"><i class="fa-solid fa-lock"></i></button>
                           
                        </div>
                    </div>
                    <div class="form-group">
                        <div class="input-container">
                            <label for="productGroup1">Product Group:</label>
                            <input type="text" id="productGroup1" name="products[1][productGroup]" required>
                             <button type="button" class="lock-btn" onclick="toggleLock('productGroup1')"><i class="fa-solid fa-lock"></i></button>
                        </div>
                        <div class="input-container">
                            <label for="productMonthlyPrice1">Product Monthly Price:</label>
                            <input type="float" id="productMonthlyPrice1" name="products[1][productMonthlyPrice]" required>
                              <button type="button" class="lock-btn" onclick="toggleLock('productMonthlyPrice1')"><i class="fa-solid fa-lock"></i></button>
                        </div>
                        <div class="input-container">
                            <label for="productMonthlySetupPrice1">Product Setup Price:</label>
                            <input type="float" id="productMonthlySetupPrice1" name="products[1][productMonthlySetupPrice]" required>
                              <button type="button" class="lock-btn" onclick="toggleLock('productMonthlySetupPrice1')"><i class="fa-solid fa-lock"></i></button>
                        </div>
                    </div>
                    <!-- Dynamic Config Options -->
                    <div class="config-options">
                        <div class="option-group">
                           <div class="input-container">
                                <label for="configOptionGroupName1_1">Config Option Group Name:  </label>
                            <input type="text" id="configOptionGroupName1_1" name="products[1][configOptionGroupName][]" required>
                              <button type="button" class="lock-btn" onclick="toggleLock('configOptionGroupName1_1')"><i class="fa-solid fa-lock"></i></button>
                           </div>
                            <button type="button" class="add-suboption">Add Sub-option</button>
                            <div class="sub-options">
                                <div class="form-group">
                                    <div class="input-container">
                                        <label for="configSubOptionName1_1_1">Sub-option Name:</label>
                                        <input type="text" id="configSubOptionName1_1_1" name="products[1][configSubOptionName][1][]" required> 
                                        <button type="button" class="lock-btn" onclick="toggleLock('configSubOptionName1_1_1')"><i class="fa-solid fa-lock"></i></button>
                                    </div>
                                    <div class="input-container">
                                        <label for="configSubOptionMonthlyPrice1_1_1">Sub-option Monthly Price:</label>
                                        <input type="float" id="configSubOptionMonthlyPrice1_1_1" name="products[1][configSubOptionMonthlyPrice][1][]" required>
                                         <button type="button" class="lock-btn" onclick="toggleLock('configSubOptionMonthlyPrice1_1_1')"><i class="fa-solid fa-lock"></i></button>
                                    </div>
                                    
                                        <div class="input-container">
                                        <label for="configSetupPrice1_1_1">Sub-option Setup Price:</label>
                                        <input type="float" id="configSetupPrice1_1_1" name="products[1][configSetupPrice][1][]" required>
                                         <button type="button" class="lock-btn" onclick="toggleLock('configSetupPrice1_1_1')"><i class="fa-solid fa-lock"></i></button>
                                    </div>
                                   
                                </div>
                            </div>
                        </div>
                    </div>
                    <button type="button" class="add-config">Add Config Option Group</button>
                </div>
            </div>
            <div style="display:flex">
                <button type="button" id="add-product" style="background-color: #ff7f00;">Add Product</button>
            
            </div>
                <div style="float:right">
                  
                    <button type="submit" style="background-color: #0ea12c;">Generate CSV</button>
                
               <button type="button" id="save-data" style="background-color: #e70c0c;color: white;padding: 10px 15px; border: none;border-radius: 4px;cursor: pointer;margin: 10px;">Save Data</button>
                </div>
        </form>
    </div>
    <script>
        $(document).ready(function() {
            let productIndex = 1;




        
            function updateProviderAndCode() {
                const commonProvider = $('#commonProvider').val();
                const commondataCenterCode = $('#commondataCenterCode').val();

                $('.provider').val(commonProvider);
                $('.dataCenterCode').val(commondataCenterCode);
            }

            $('#commonProvider, #commondataCenterCode').on('input', updateProviderAndCode);

            // Add new product
            $('#add-product').click(function() {
                productIndex++;
                let newProduct = `
                    <div class="product" style="margin-top:60px">
                        <h3>Product ${productIndex} </h3>
                        <div class="form-group">
                           <div class="input-container">
                                <label for="productID${productIndex}">Product ID:</label>
                                <input type="text" id="productID${productIndex}" name="products[${productIndex}][productID]" required>
                                  <button type="button" class="lock-btn" onclick="toggleLock('productID${productIndex}')"><i class="fa-solid fa-lock"></i></button>
                            </div>
                              <div class="input-container">
                                <label for="productName${productIndex}">Product Name:</label>
                                <input type="text" id="productName${productIndex}" name="products[${productIndex}][productName]" required>
                                 <button type="button" class="lock-btn" onclick="toggleLock('productName${productIndex}')"><i class="fa-solid fa-lock"></i></button>
                            </div>
                            <div class="input-container">
                                <label for="productDescription${productIndex}">Product Description:</label>
                                <textarea id="productDescription${productIndex}" name="products[${productIndex}][productDescription]" rows="4"></textarea>
                                 <button type="button" class="lock-btn" onclick="toggleLock('productDescription${productIndex}')"><i class="fa-solid fa-lock"></i></button>
                            </div>
                              <div class="input-container">
                                <label for="provider${productIndex}">Provider:</label>
                                <input type="text" id="provider${productIndex}" name="products[${productIndex}][provider]" class="provider" required>
                                 <button type="button" class="lock-btn" onclick="toggleLock('provider${productIndex}')"><i class="fa-solid fa-lock"></i></button>
                            </div>
                              <div class="input-container">
                                <label for="dataCenterCode${productIndex}">Data Center Code:</label>
                                <input type="text" id="dataCenterCode${productIndex}" name="products[${productIndex}][dataCenterCode]" class="dataCenterCode" required>
                                <button type="button" class="lock-btn" onclick="toggleLock('dataCenterCode${productIndex}')"><i class="fa-solid fa-lock"></i></button>
                            </div>
                        </div>
                        <div class="form-group">
                              <div class="input-container">
                                <label for="productGroup${productIndex}">Product Group:</label>
                                <input type="text" id="productGroup${productIndex}" name="products[${productIndex}][productGroup]" required>
                                 <button type="button" class="lock-btn" onclick="toggleLock('productGroup${productIndex}')"><i class="fa-solid fa-lock"></i></button>
                            </div>
                              <div class="input-container">
                                <label for="productMonthlyPrice${productIndex}">Product Monthly Price:</label>
                                <input type="float" id="productMonthlyPrice${productIndex}" name="products[${productIndex}][productMonthlyPrice]" required>
                                 <button type="button" class="lock-btn" onclick="toggleLock('productMonthlyPrice${productIndex}')"><i class="fa-solid fa-lock"></i></button>
                            </div>
                             <div class="input-container">
                                <label for="productMonthlySetupPrice${productIndex}">Product Monthly Setup Price:</label>
                                <input type="float" id="productMonthlySetupPrice${productIndex}" name="products[${productIndex}][productMonthlySetupPrice]" required>
                                 <button type="button" class="lock-btn" onclick="toggleLock('productMonthlySetupPrice${productIndex}')"><i class="fa-solid fa-lock"></i></button>
                            </div>
                        </div>
                        <!-- Dynamic Config Options -->
                        <div class="config-options">
                            <div class="option-group">
                               <div class="input-container">
                                <label for="configOptionGroupName${productIndex}_1">Config Option Group Name: </label>
                                <input type="text" id="configOptionGroupName${productIndex}_1" name="products[${productIndex}][configOptionGroupName][]" required>
                                <button type="button" class="lock-btn" onclick="toggleLock('configOptionGroupName${productIndex}_1')"><i class="fa-solid fa-lock"></i></button>
                               </div>
                               
                                <button type="button" class="add-suboption">Add Sub-option</button>
                                <div class="sub-options">
                                    <div class="form-group">
                                         <div class="input-container">
                                            <label for="configSubOptionName${productIndex}_1_1">Sub-option Name:</label>
                                            <input type="float" id="configSubOptionName${productIndex}_1_1" name="products[${productIndex}][configSubOptionName][1][]" required>
                                            <button type="button" class="lock-btn" onclick="toggleLock('configSubOptionName${productIndex}_1_1')"><i class="fa-solid fa-lock"></i></button>
                                        </div>
                                         <div class="input-container">
                                            <label for="configSubOptionMonthlyPrice${productIndex}_1_1">Sub-option Monthly Price:</label>
                                            <input type="float" id="configSubOptionMonthlyPrice${productIndex}_1_1" name="products[${productIndex}][configSubOptionMonthlyPrice][1][]" required>
                                            <button type="button" class="lock-btn" onclick="toggleLock('configSubOptionMonthlyPrice${productIndex}_1_1')"><i class="fa-solid fa-lock"></i></button>
                                        </div>
                                        
                                            <div class="input-container">
                                            <label for="configSetupPrice${productIndex}_1_1">Sub-option Setup Price:</label>
                                            <input type="float" id="configSetupPrice${productIndex}_1_1" name="products[${productIndex}][configSetupPrice][1][]" required>
                                            <button type="button" class="lock-btn" onclick="toggleLock('configSetupPrice${productIndex}_1_1')"><i class="fa-solid fa-lock"></i></button>
                                        </div>
                                        
                                    </div>
                                </div>
                            </div>
                        </div>
                        <button type="button" class="add-config">Add Config Option Group</button>
                    </div>`;
                $('#products').append(newProduct);
                updateProviderAndCode();
                 autoSaveFormData(); 
            });

            // Add new sub-option
            $(document).on('click', '.add-suboption', function() {
                let subOptionGroup = $(this).siblings('.sub-options');
                let productId = subOptionGroup.closest('.product').index() + 1;
                let optionGroupId = $(this).parent('.option-group').index() + 1;
                let subOptionIndex = subOptionGroup.children('.form-group').length + 1;

                let newSubOption = `
                    <div class="form-group">
                        <div class="input-container">
                            <label for="configSubOptionName${productId}_${optionGroupId}_${subOptionIndex}">Sub-option Name:</label>
                            <input type="text" id="configSubOptionName${productId}_${optionGroupId}_${subOptionIndex}" name="products[${productId}][configSubOptionName][${optionGroupId}][]" required>
                             <button type="button" class="lock-btn" onclick="toggleLock('configSubOptionName${productId}_${optionGroupId}_${subOptionIndex}')"><i class="fa-solid fa-lock"></i></button>
                        </div>
                        <div class="input-container">
                            <label for="configSubOptionMonthlyPrice${productId}_${optionGroupId}_${subOptionIndex}">Sub-option Monthly Price:</label>
                            <input type="float" id="configSubOptionMonthlyPrice${productId}_${optionGroupId}_${subOptionIndex}" name="products[${productId}][configSubOptionMonthlyPrice][${optionGroupId}][]" required>
                             <button type="button" class="lock-btn" onclick="toggleLock('configSubOptionMonthlyPrice${productId}_${optionGroupId}_${subOptionIndex}')"><i class="fa-solid fa-lock"></i></button>
                        </div>
                        
                           <div class="input-container">
                            <label for="configSetupPrice${productId}_${optionGroupId}_${subOptionIndex}">Sub-option Setup Price:</label>
                            <input type="float" id="configSetupPrice${productId}_${optionGroupId}_${subOptionIndex}" name="products[${productId}][configSetupPrice][${optionGroupId}][]" required>
                             <button type="button" class="lock-btn" onclick="toggleLock('configSetupPrice${productId}_${optionGroupId}_${subOptionIndex}')"><i class="fa-solid fa-lock"></i></button>
                        </div>
                        
                    </div>`;
                subOptionGroup.append(newSubOption);
                autoSaveFormData();
                
            });

        

       $('#save-data').click(function() {
            // Gather form data
            let formData = $('#productForm').serialize();

            // Send data to save_data.php via AJAX
            $.ajax({
                url: 'save_data.php',
                method: 'POST',
                data: formData,
                success: function(response) {
                    alert('Data saved successfully!');
                    // Optionally, reset the form or perform other actions
                },
                error: function(xhr, status, error) {
                    alert('Error saving data: ' + error);
                }
            });
        });
            // Add new config option group
            $(document).on('click', '.add-config', function() {
                let productId = $(this).closest('.product').index() + 1;
                let optionGroupIndex = $(this).siblings('.config-options').children('.option-group').length + 1;

                let newConfigOptionGroup = `
                    <div class="option-group">
                        <div class="input-container">
                        <label for="configOptionGroupName${productId}_${optionGroupIndex}">Config Option Group Name: </label>
                        <input type="text" id="configOptionGroupName${productId}_${optionGroupIndex}" name="products[${productId}][configOptionGroupName][]" required>
                         <button type="button" class="lock-btn" onclick="toggleLock('configOptionGroupName${productId}_${optionGroupIndex}')"><i class="fa-solid fa-lock"></i></button>
                       </div>
                       
                        <button type="button" class="add-suboption">Add Sub-option</button>
                        <div class="sub-options">
                            <div class="form-group">
                                <div class="input-container">
                                    <label for="configSubOptionName${productId}_${optionGroupIndex}_1">Sub-option Name:</label>
                                    <input type="text" id="configSubOptionName${productId}_${optionGroupIndex}_1" name="products[${productId}][configSubOptionName][${optionGroupIndex}][]" required>
                                     <button type="button" class="lock-btn" onclick="toggleLock('configSubOptionName${productId}_${optionGroupIndex}_1')"><i class="fa-solid fa-lock"></i></button>
                                </div>
                                <div class="input-container">
                                    <label for="configSubOptionMonthlyPrice${productId}_${optionGroupIndex}_1">Sub-option Monthly Price:</label>
                                    <input type="float" id="configSubOptionMonthlyPrice${productId}_${optionGroupIndex}_1" name="products[${productId}][configSubOptionMonthlyPrice][${optionGroupIndex}][]" required>
                                     <button type="button" class="lock-btn" onclick="toggleLock('configSubOptionMonthlyPrice${productId}_${optionGroupIndex}_1')"><i class="fa-solid fa-lock"></i></button>
                                </div>
                                   <div class="input-container">
                                    <label for="configSetupPrice${productId}_${optionGroupIndex}_1">Sub-option Setup Price:</label>
                                    <input type="float" id="configSetupPrice${productId}_${optionGroupIndex}_1" name="products[${productId}][configSetupPrice][${optionGroupIndex}][]" required>
                                     <button type="button" class="lock-btn" onclick="toggleLock('configSetupPrice${productId}_${optionGroupIndex}_1')"><i class="fa-solid fa-lock"></i></button>
                                </div>
                               
                            </div>
                        </div>
                    </div>`;
                $(this).siblings('.config-options').append(newConfigOptionGroup);
                autoSaveFormData();
            });

         

            // Function to autosave form data
            function autoSaveFormData() {
                // Gather form data
                let formData = $('#productForm').serialize();

                // Send data to save_data.php via AJAX
                $.ajax({
                    url: 'save_data.php',
                    method: 'POST',
                    data: formData,
                    success: function(response) {
                        console.log('Data autosaved successfully:', response);
                    },
                    error: function(xhr, status, error) {
                        console.error('Error autosaving data:', error);
                    }
                });
            }

                // Autosave when any input field changes
            setInterval(function() {
                autoSaveFormData();
            }, 30000); // Autosave every 30 seconds

       
        });
    </script>
    <script>
        function toggleLock(inputId) {
            const inputField = document.getElementById(inputId);

            if (inputField.readOnly) {
                inputField.readOnly = false;
                inputField.value = ''; // Optionally clear the value when unlocked
                inputField.style.backgroundColor = ""; // Reset background color
            } else {
                inputField.readOnly = true;
                inputField.value = 'error'; // Set the value to "error"
                inputField.style.backgroundColor = "#f8d7da"; // Optionally change background color
            }
        }
    </script>
    <script src="https://kit.fontawesome.com/b27b646f22.js" crossorigin="anonymous"></script>
</body>
</html>
