<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

session_start();
    ini_set('memory_limit', '4096M'); // 2 GB memory limit
    ini_set('max_execution_time', 3600); // 20 minutes
    ini_set('max_input_nesting_level', 256);
    ini_set('max_input_time', 3600);
    ini_set('max_input_vars', 18000);
    ini_set('post_max_size', '4096M');
    ini_set('upload_max_filesize','4096M');   
if (!isset($_SESSION['tableName']) || empty($_SESSION['tableName'])) {
    die('Error: Table name not set in session.');
}

$tableName = $_SESSION['tableName'];

if ($_SERVER["REQUEST_METHOD"] == "POST") {

      // Check if 'products' POST array is empty
    if (empty($_POST['products']) || !is_array($_POST['products'])) {
        die('Error: No products data received.');
    }

 // Check if all 'dataCenterCode' values are empty
    $alldataCenterCodesEmpty = true;
    foreach ($_POST['products'] as $product) {
        if (!empty($product['dataCenterCode'])) {
            $alldataCenterCodesEmpty = false;
            break; // At least one product has a non-empty dataCenterCode, so we can stop checking
        }
    }

    if ($alldataCenterCodesEmpty) {
        die('Error: All Data Center Codes are empty. No products to save.');
    }


// Database connection
                        $servername = "localhost";
                        $username = "efox_dataEntry";
                        $password = "qYkVUsc5ST8mAXR2kWce";
                        $dbname = "efox_dataEntry";

    $conversionRate = isset($_POST['conversionRate']) ? (float)$_POST['conversionRate'] : 1.0;

    // Create connection
    $conn = new mysqli($servername, $username, $password, $dbname);

    // Check connection
    if ($conn->connect_error) {
        die("Connection failed: " . $conn->connect_error);
    }

    // Check if the table exists
    $checkTableSQL = "SHOW TABLES LIKE '$tableName'";
    $result = $conn->query($checkTableSQL);

    if ($result->num_rows == 0) {
        // Table does not exist, create it
        $createTableSQL = "CREATE TABLE `$tableName` (
            id INT(11) AUTO_INCREMENT PRIMARY KEY,
            productID VARCHAR(255),
            productName VARCHAR(255),
            productDescription TEXT,
            dataCenterCode VARCHAR(255),
            productGroup VARCHAR(255),
             provider VARCHAR(255),
            configOptionGroupName VARCHAR(255),
            configSubOptionName VARCHAR(255),
            configSubOptionMonthlyPrice DECIMAL(10, 2),
            configSetupPrice DECIMAL(10, 2),
             productMonthlyPrice DECIMAL(10, 2),
            productMonthlySetupPrice DECIMAL(10, 2),
            conversionRate DECIMAL(15, 10) DEFAULT 1.0
        )";

        if (!$conn->query($createTableSQL)) {
            die("Error creating table: " . $conn->error);
        }
    } else {
        // Table exists, delete all existing data
        $deleteSQL = "DELETE FROM `$tableName`";
        if (!$conn->query($deleteSQL)) {
            die("Error deleting existing data: " . $conn->error);
        }
    }

    // Process each product
    foreach ($_POST['products'] as $product) {
       $productID = $conn->real_escape_string($product['productID'] ?? '');
$productName = $conn->real_escape_string($product['productName'] ?? '');
$productDescription = $conn->real_escape_string($product['productDescription'] ?? '');

$dataCenterCode = $conn->real_escape_string($product['dataCenterCode'] ?? '');
$productGroup = $conn->real_escape_string($product['productGroup'] ?? '');
$provider = $conn->real_escape_string($product['provider'] ?? '');

$cleandataCenterCode = str_replace(' ', '', $product['dataCenterCode'] ?? '');
$cleanProductGroup = str_replace(' ', '', $product['productGroup'] ?? '');

$productMonthlyPrice = (float)($product['productMonthlyPrice'] ?? 0);
$productMonthlySetupPrice = (float)($product['productMonthlySetupPrice'] ?? 0);

      

        // Insert configuration options and sub-options if available
  if (isset($product['configOptionGroupName'])) {
    foreach ($product['configOptionGroupName'] as $key => $groupName) {
        if (isset($product['configSubOptionName'][$key + 1])) {
            foreach ($product['configSubOptionName'][$key + 1] as $index => $subOptionName) {
                if (isset($product['configSubOptionMonthlyPrice'][$key + 1][$index])) {
                    $monthlyPrice = (float)$product['configSubOptionMonthlyPrice'][$key + 1][$index];
                   $configSetupPrice = (float)$product['configSetupPrice'][$key + 1][$index];

                    $sql = "INSERT INTO `$tableName` (
                        productID, productName, productDescription, dataCenterCode, productGroup, provider, configOptionGroupName, configSubOptionName,configSubOptionMonthlyPrice, configSetupPrice,
                        productMonthlyPrice, productMonthlySetupPrice, conversionRate
                    ) VALUES (
                       '$productID', '$productName', '$productDescription', '$dataCenterCode', '$productGroup', '$provider', '$groupName' , '$subOptionName', '$monthlyPrice',  '$configSetupPrice',
                        '$productMonthlyPrice', '$productMonthlySetupPrice', '$conversionRate'
                      
                    )";

                    if (!$conn->query($sql)) {
                        die("Error: " . $sql . "<br>" . $conn->error);
                    }
                } else {
                    // Log the missing configSubOptionMonthlyPrice index
                    error_log("Missing configSubOptionMonthlyPrice index:  key $key, index $index");
                }
            }
        } else {
            // Log the missing configSubOptionName index
            error_log("Missing configSubOptionName index: productIndex $productIndex, key $key");
        }
    }
}

    }

    // Close the database connection
    $conn->close();

    // Success message or redirection after saving
    echo "Products saved successfully!";
    exit();
}


?>
